/* Generated from Salut-specific extensions to the Telepathy interfaces

Copyright (C) 2007 Collabora Limited

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA


 */

#ifdef __cplusplus
extern "C" {
#endif

/**
 *
SalutTubeChannelState:
 * @SALUT_TUBE_CHANNEL_STATE_LOCAL_PENDING: <![CDATA[           The initiator offered the tube. The tube is waiting to be           accepted/closed locally. If the client accepts the tube, the tube's           state will be Open.         ]]>
 * @SALUT_TUBE_CHANNEL_STATE_REMOTE_PENDING: <![CDATA[           The tube is waiting to be accepted/closed remotely. If the           recipient accepts the tube, the tube's state will be Open.         ]]>
 * @SALUT_TUBE_CHANNEL_STATE_OPEN: <![CDATA[           The initiator offered the tube and the recipient accepted it. The           tube is open for traffic. The tube's state stays in this state until           it is closed.         ]]>
 * @SALUT_TUBE_CHANNEL_STATE_NOT_OFFERED: <![CDATA[           The tube channel has been requested but the tube is not yet offered.           The client should offer the tube to the recipient and the tube's           state will be Remote_Pending. The method to offer the tube depend on           the tube type.         ]]>
 *
 * Bitfield/set of flags generated from the Telepathy specification.
 */
typedef enum {
    SALUT_TUBE_CHANNEL_STATE_LOCAL_PENDING = 0,
    SALUT_TUBE_CHANNEL_STATE_REMOTE_PENDING = 1,
    SALUT_TUBE_CHANNEL_STATE_OPEN = 2,
    SALUT_TUBE_CHANNEL_STATE_NOT_OFFERED = 3,
} SalutTubeChannelState;

/**
 * NUM_SALUT_TUBE_CHANNEL_STATES:
 *
 * 1 higher than the highest valid value of #SalutTubeChannelState.
 */
#define NUM_SALUT_TUBE_CHANNEL_STATES (3+1)


#ifdef __cplusplus
}
#endif
