#include "_gen/svc.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _salut_svc_channel_interface_tube_object_info;

struct _SalutSvcChannelInterfaceTubeClass {
    GTypeInterface parent_class;
};

enum {
    SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged,
    N_CHANNEL_INTERFACE_TUBE_SIGNALS
};
static guint channel_interface_tube_signals[N_CHANNEL_INTERFACE_TUBE_SIGNALS] = {0};

static void salut_svc_channel_interface_tube_base_init (gpointer klass);

GType
salut_svc_channel_interface_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcChannelInterfaceTubeClass),
        salut_svc_channel_interface_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcChannelInterfaceTube", &info, 0);
    }

  return type;
}

/**
 * salut_svc_channel_interface_tube_emit_tube_channel_state_changed:
 * @instance: The object implementing this interface
 * @arg_state: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * TubeChannelStateChanged signal on interface org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT.
 */
void
salut_svc_channel_interface_tube_emit_tube_channel_state_changed (gpointer instance,
    guint arg_state)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE));
  g_signal_emit (instance,
      channel_interface_tube_signals[SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged],
      0,
      arg_state);
}

static inline void
salut_svc_channel_interface_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{sv}", 0, NULL, NULL }, /* Parameters */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "u", 0, NULL, NULL }, /* State */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT");
  properties[0].name = g_quark_from_static_string ("Parameters");
  properties[0].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE));
  properties[1].name = g_quark_from_static_string ("State");
  properties[1].type = G_TYPE_UINT;
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_CHANNEL_INTERFACE_TUBE, &interface);

  channel_interface_tube_signals[SIGNAL_CHANNEL_INTERFACE_TUBE_TubeChannelStateChanged] =
  g_signal_new ("tube-channel-state-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (salut_svc_channel_interface_tube_get_type (),
      &_salut_svc_channel_interface_tube_object_info);
}
static void
salut_svc_channel_interface_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_channel_interface_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_channel_interface_tube_methods[] = {
};

static const DBusGObjectInfo _salut_svc_channel_interface_tube_object_info = {
  0,
  _salut_svc_channel_interface_tube_methods,
  0,
"\0",
"org.freedesktop.Telepathy.Channel.Interface.Tube.DRAFT\0TubeChannelStateChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_channel_type_dbus_tube_object_info;

struct _SalutSvcChannelTypeDBusTubeClass {
    GTypeInterface parent_class;
    salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl offer_d_bus_tube;
    salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl accept_d_bus_tube;
};

enum {
    SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged,
    N_CHANNEL_TYPE_DBUS_TUBE_SIGNALS
};
static guint channel_type_dbus_tube_signals[N_CHANNEL_TYPE_DBUS_TUBE_SIGNALS] = {0};

static void salut_svc_channel_type_dbus_tube_base_init (gpointer klass);

GType
salut_svc_channel_type_dbus_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcChannelTypeDBusTubeClass),
        salut_svc_channel_type_dbus_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcChannelTypeDBusTube", &info, 0);
    }

  return type;
}

/**
 * salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl:
 * @self: The object implementing this interface
 * @in_parameters: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * OfferDBusTube on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
static void
salut_svc_channel_type_dbus_tube_offer_d_bus_tube (SalutSvcChannelTypeDBusTube *self,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS (self)->offer_d_bus_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_parameters,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_dbus_tube_implement_offer_d_bus_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the OfferDBusTube D-Bus method
 *
 * Register an implementation for the OfferDBusTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_dbus_tube_implement_offer_d_bus_tube (SalutSvcChannelTypeDBusTubeClass *klass, salut_svc_channel_type_dbus_tube_offer_d_bus_tube_impl impl)
{
  klass->offer_d_bus_tube = impl;
}

/**
 * salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AcceptDBusTube on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
static void
salut_svc_channel_type_dbus_tube_accept_d_bus_tube (SalutSvcChannelTypeDBusTube *self,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_DBUS_TUBE_GET_CLASS (self)->accept_d_bus_tube);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_dbus_tube_implement_accept_d_bus_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcceptDBusTube D-Bus method
 *
 * Register an implementation for the AcceptDBusTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_dbus_tube_implement_accept_d_bus_tube (SalutSvcChannelTypeDBusTubeClass *klass, salut_svc_channel_type_dbus_tube_accept_d_bus_tube_impl impl)
{
  klass->accept_d_bus_tube = impl;
}

/**
 * salut_svc_channel_type_dbus_tube_emit_d_bus_names_changed:
 * @instance: The object implementing this interface
 * @arg_added: GHashTable * (FIXME, generate documentation)
 * @arg_removed: const GArray * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * DBusNamesChanged signal on interface org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT.
 */
void
salut_svc_channel_type_dbus_tube_emit_d_bus_names_changed (gpointer instance,
    GHashTable *arg_added,
    const GArray *arg_removed)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE));
  g_signal_emit (instance,
      channel_type_dbus_tube_signals[SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged],
      0,
      arg_added,
      arg_removed);
}

static inline void
salut_svc_channel_type_dbus_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* ServiceName */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{us}", 0, NULL, NULL }, /* DBusNames */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT");
  properties[0].name = g_quark_from_static_string ("ServiceName");
  properties[0].type = G_TYPE_STRING;
  properties[1].name = g_quark_from_static_string ("DBusNames");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_STRING));
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_CHANNEL_TYPE_DBUS_TUBE, &interface);

  channel_type_dbus_tube_signals[SIGNAL_CHANNEL_TYPE_DBUS_TUBE_DBusNamesChanged] =
  g_signal_new ("d-bus-names-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__BOXED_BOXED,
      G_TYPE_NONE,
      2,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, G_TYPE_STRING)),
      DBUS_TYPE_G_UINT_ARRAY);

  dbus_g_object_type_install_info (salut_svc_channel_type_dbus_tube_get_type (),
      &_salut_svc_channel_type_dbus_tube_object_info);
}
static void
salut_svc_channel_type_dbus_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_channel_type_dbus_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_channel_type_dbus_tube_methods[] = {
  { (GCallback) salut_svc_channel_type_dbus_tube_offer_d_bus_tube, _salut_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) salut_svc_channel_type_dbus_tube_accept_d_bus_tube, g_cclosure_marshal_VOID__POINTER, 106 },
};

static const DBusGObjectInfo _salut_svc_channel_type_dbus_tube_object_info = {
  0,
  _salut_svc_channel_type_dbus_tube_methods,
  2,
"org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0OfferDBusTube\0A\0parameters\0I\0a{sv}\0address\0O\0F\0N\0s\0\0org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0AcceptDBusTube\0A\0address\0O\0F\0N\0s\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.DBusTube.DRAFT\0DBusNamesChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_channel_type_stream_tube_object_info;

struct _SalutSvcChannelTypeStreamTubeClass {
    GTypeInterface parent_class;
    salut_svc_channel_type_stream_tube_offer_stream_tube_impl offer_stream_tube;
    salut_svc_channel_type_stream_tube_accept_stream_tube_impl accept_stream_tube;
};

enum {
    SIGNAL_CHANNEL_TYPE_STREAM_TUBE_StreamTubeNewConnection,
    N_CHANNEL_TYPE_STREAM_TUBE_SIGNALS
};
static guint channel_type_stream_tube_signals[N_CHANNEL_TYPE_STREAM_TUBE_SIGNALS] = {0};

static void salut_svc_channel_type_stream_tube_base_init (gpointer klass);

GType
salut_svc_channel_type_stream_tube_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcChannelTypeStreamTubeClass),
        salut_svc_channel_type_stream_tube_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcChannelTypeStreamTube", &info, 0);
    }

  return type;
}

/**
 * salut_svc_channel_type_stream_tube_offer_stream_tube_impl:
 * @self: The object implementing this interface
 * @in_address_type: guint  (FIXME, generate documentation)
 * @in_address: const GValue * (FIXME, generate documentation)
 * @in_access_control: guint  (FIXME, generate documentation)
 * @in_access_control_param: const GValue * (FIXME, generate documentation)
 * @in_parameters: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * OfferStreamTube on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
static void
salut_svc_channel_type_stream_tube_offer_stream_tube (SalutSvcChannelTypeStreamTube *self,
    guint in_address_type,
    const GValue *in_address,
    guint in_access_control,
    const GValue *in_access_control_param,
    GHashTable *in_parameters,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_stream_tube_offer_stream_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS (self)->offer_stream_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_address_type,
        in_address,
        in_access_control,
        in_access_control_param,
        in_parameters,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_stream_tube_implement_offer_stream_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the OfferStreamTube D-Bus method
 *
 * Register an implementation for the OfferStreamTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_stream_tube_implement_offer_stream_tube (SalutSvcChannelTypeStreamTubeClass *klass, salut_svc_channel_type_stream_tube_offer_stream_tube_impl impl)
{
  klass->offer_stream_tube = impl;
}

/**
 * salut_svc_channel_type_stream_tube_accept_stream_tube_impl:
 * @self: The object implementing this interface
 * @in_address_type: guint  (FIXME, generate documentation)
 * @in_access_control: guint  (FIXME, generate documentation)
 * @in_access_control_param: const GValue * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * AcceptStreamTube on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
static void
salut_svc_channel_type_stream_tube_accept_stream_tube (SalutSvcChannelTypeStreamTube *self,
    guint in_address_type,
    guint in_access_control,
    const GValue *in_access_control_param,
    DBusGMethodInvocation *context)
{
  salut_svc_channel_type_stream_tube_accept_stream_tube_impl impl = (SALUT_SVC_CHANNEL_TYPE_STREAM_TUBE_GET_CLASS (self)->accept_stream_tube);

  if (impl != NULL)
    {
      (impl) (self,
        in_address_type,
        in_access_control,
        in_access_control_param,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_channel_type_stream_tube_implement_accept_stream_tube:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the AcceptStreamTube D-Bus method
 *
 * Register an implementation for the AcceptStreamTube method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_channel_type_stream_tube_implement_accept_stream_tube (SalutSvcChannelTypeStreamTubeClass *klass, salut_svc_channel_type_stream_tube_accept_stream_tube_impl impl)
{
  klass->accept_stream_tube = impl;
}

/**
 * salut_svc_channel_type_stream_tube_emit_stream_tube_new_connection:
 * @instance: The object implementing this interface
 * @arg_handle: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * StreamTubeNewConnection signal on interface org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT.
 */
void
salut_svc_channel_type_stream_tube_emit_stream_tube_new_connection (gpointer instance,
    guint arg_handle)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE));
  g_signal_emit (instance,
      channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_StreamTubeNewConnection],
      0,
      arg_handle);
}

static inline void
salut_svc_channel_type_stream_tube_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[3] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "s", 0, NULL, NULL }, /* Service */
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{uau}", 0, NULL, NULL }, /* SupportedSocketTypes */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT");
  properties[0].name = g_quark_from_static_string ("Service");
  properties[0].type = G_TYPE_STRING;
  properties[1].name = g_quark_from_static_string ("SupportedSocketTypes");
  properties[1].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, DBUS_TYPE_G_UINT_ARRAY));
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_CHANNEL_TYPE_STREAM_TUBE, &interface);

  channel_type_stream_tube_signals[SIGNAL_CHANNEL_TYPE_STREAM_TUBE_StreamTubeNewConnection] =
  g_signal_new ("stream-tube-new-connection",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__UINT,
      G_TYPE_NONE,
      1,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (salut_svc_channel_type_stream_tube_get_type (),
      &_salut_svc_channel_type_stream_tube_object_info);
}
static void
salut_svc_channel_type_stream_tube_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_channel_type_stream_tube_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_channel_type_stream_tube_methods[] = {
  { (GCallback) salut_svc_channel_type_stream_tube_offer_stream_tube, _salut_ext_marshal_VOID__UINT_BOXED_UINT_BOXED_BOXED_POINTER, 0 },
  { (GCallback) salut_svc_channel_type_stream_tube_accept_stream_tube, _salut_ext_marshal_VOID__UINT_UINT_BOXED_POINTER, 167 },
};

static const DBusGObjectInfo _salut_svc_channel_type_stream_tube_object_info = {
  0,
  _salut_svc_channel_type_stream_tube_methods,
  2,
"org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0OfferStreamTube\0A\0address_type\0I\0u\0address\0I\0v\0access_control\0I\0u\0access_control_param\0I\0v\0parameters\0I\0a{sv}\0\0org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0AcceptStreamTube\0A\0address_type\0I\0u\0access_control\0I\0u\0access_control_param\0I\0v\0address\0O\0F\0N\0v\0\0\0",
"org.freedesktop.Telepathy.Channel.Type.StreamTube.DRAFT\0StreamTubeNewConnection\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_connection_interface_contact_capabilities_object_info;

struct _SalutSvcConnectionInterfaceContactCapabilitiesClass {
    GTypeInterface parent_class;
    salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl set_self_capabilities;
    salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl get_contact_capabilities;
};

enum {
    SIGNAL_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_ContactCapabilitiesChanged,
    N_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_SIGNALS
};
static guint connection_interface_contact_capabilities_signals[N_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_SIGNALS] = {0};

static void salut_svc_connection_interface_contact_capabilities_base_init (gpointer klass);

GType
salut_svc_connection_interface_contact_capabilities_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcConnectionInterfaceContactCapabilitiesClass),
        salut_svc_connection_interface_contact_capabilities_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcConnectionInterfaceContactCapabilities", &info, 0);
    }

  return type;
}

/**
 * salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl:
 * @self: The object implementing this interface
 * @in_caps: const GPtrArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetSelfCapabilities on interface org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT.
 */
static void
salut_svc_connection_interface_contact_capabilities_set_self_capabilities (SalutSvcConnectionInterfaceContactCapabilities *self,
    const GPtrArray *in_caps,
    DBusGMethodInvocation *context)
{
  salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl impl = (SALUT_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_GET_CLASS (self)->set_self_capabilities);

  if (impl != NULL)
    {
      (impl) (self,
        in_caps,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_connection_interface_contact_capabilities_implement_set_self_capabilities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetSelfCapabilities D-Bus method
 *
 * Register an implementation for the SetSelfCapabilities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_connection_interface_contact_capabilities_implement_set_self_capabilities (SalutSvcConnectionInterfaceContactCapabilitiesClass *klass, salut_svc_connection_interface_contact_capabilities_set_self_capabilities_impl impl)
{
  klass->set_self_capabilities = impl;
}

/**
 * salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl:
 * @self: The object implementing this interface
 * @in_handles: const GArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetContactCapabilities on interface org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT.
 */
static void
salut_svc_connection_interface_contact_capabilities_get_contact_capabilities (SalutSvcConnectionInterfaceContactCapabilities *self,
    const GArray *in_handles,
    DBusGMethodInvocation *context)
{
  salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl impl = (SALUT_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_GET_CLASS (self)->get_contact_capabilities);

  if (impl != NULL)
    {
      (impl) (self,
        in_handles,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_connection_interface_contact_capabilities_implement_get_contact_capabilities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetContactCapabilities D-Bus method
 *
 * Register an implementation for the GetContactCapabilities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_connection_interface_contact_capabilities_implement_get_contact_capabilities (SalutSvcConnectionInterfaceContactCapabilitiesClass *klass, salut_svc_connection_interface_contact_capabilities_get_contact_capabilities_impl impl)
{
  klass->get_contact_capabilities = impl;
}

/**
 * salut_svc_connection_interface_contact_capabilities_emit_contact_capabilities_changed:
 * @instance: The object implementing this interface
 * @arg_caps: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ContactCapabilitiesChanged signal on interface org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT.
 */
void
salut_svc_connection_interface_contact_capabilities_emit_contact_capabilities_changed (gpointer instance,
    GHashTable *arg_caps)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES));
  g_signal_emit (instance,
      connection_interface_contact_capabilities_signals[SIGNAL_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_ContactCapabilitiesChanged],
      0,
      arg_caps);
}

static inline void
salut_svc_connection_interface_contact_capabilities_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_CONNECTION_INTERFACE_CONTACT_CAPABILITIES, &interface);

  connection_interface_contact_capabilities_signals[SIGNAL_CONNECTION_INTERFACE_CONTACT_CAPABILITIES_ContactCapabilitiesChanged] =
  g_signal_new ("contact-capabilities-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      g_cclosure_marshal_VOID__BOXED,
      G_TYPE_NONE,
      1,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_UINT, (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)), G_TYPE_STRV, G_TYPE_INVALID)))))));

  dbus_g_object_type_install_info (salut_svc_connection_interface_contact_capabilities_get_type (),
      &_salut_svc_connection_interface_contact_capabilities_object_info);
}
static void
salut_svc_connection_interface_contact_capabilities_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_connection_interface_contact_capabilities_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_connection_interface_contact_capabilities_methods[] = {
  { (GCallback) salut_svc_connection_interface_contact_capabilities_set_self_capabilities, _salut_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) salut_svc_connection_interface_contact_capabilities_get_contact_capabilities, _salut_ext_marshal_VOID__BOXED_POINTER, 110 },
};

static const DBusGObjectInfo _salut_svc_connection_interface_contact_capabilities_object_info = {
  0,
  _salut_svc_connection_interface_contact_capabilities_methods,
  2,
"org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT\0SetSelfCapabilities\0A\0caps\0I\0aa{sv}\0\0org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT\0GetContactCapabilities\0A\0handles\0I\0au\0arg1\0O\0F\0N\0a{ua(a{sv}as)}\0\0\0",
"org.freedesktop.Telepathy.Connection.Interface.ContactCapabilities.DRAFT\0ContactCapabilitiesChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_olpc_activity_properties_object_info;

struct _SalutSvcOLPCActivityPropertiesClass {
    GTypeInterface parent_class;
    salut_svc_olpc_activity_properties_set_properties_impl set_properties;
    salut_svc_olpc_activity_properties_get_properties_impl get_properties;
};

enum {
    SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged,
    N_OLPC_ACTIVITY_PROPERTIES_SIGNALS
};
static guint olpc_activity_properties_signals[N_OLPC_ACTIVITY_PROPERTIES_SIGNALS] = {0};

static void salut_svc_olpc_activity_properties_base_init (gpointer klass);

GType
salut_svc_olpc_activity_properties_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcOLPCActivityPropertiesClass),
        salut_svc_olpc_activity_properties_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcOLPCActivityProperties", &info, 0);
    }

  return type;
}

/**
 * salut_svc_olpc_activity_properties_set_properties_impl:
 * @self: The object implementing this interface
 * @in_room: guint  (FIXME, generate documentation)
 * @in_properties: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetProperties on interface org.laptop.Telepathy.ActivityProperties.
 */
static void
salut_svc_olpc_activity_properties_set_properties (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    GHashTable *in_properties,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_activity_properties_set_properties_impl impl = (SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->set_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_room,
        in_properties,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_activity_properties_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties D-Bus method
 *
 * Register an implementation for the SetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_activity_properties_implement_set_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * salut_svc_olpc_activity_properties_get_properties_impl:
 * @self: The object implementing this interface
 * @in_room: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetProperties on interface org.laptop.Telepathy.ActivityProperties.
 */
static void
salut_svc_olpc_activity_properties_get_properties (SalutSvcOLPCActivityProperties *self,
    guint in_room,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_activity_properties_get_properties_impl impl = (SALUT_SVC_OLPC_ACTIVITY_PROPERTIES_GET_CLASS (self)->get_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_room,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_activity_properties_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties D-Bus method
 *
 * Register an implementation for the GetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_activity_properties_implement_get_properties (SalutSvcOLPCActivityPropertiesClass *klass, salut_svc_olpc_activity_properties_get_properties_impl impl)
{
  klass->get_properties = impl;
}

/**
 * salut_svc_olpc_activity_properties_emit_activity_properties_changed:
 * @instance: The object implementing this interface
 * @arg_room: guint  (FIXME, generate documentation)
 * @arg_properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ActivityPropertiesChanged signal on interface org.laptop.Telepathy.ActivityProperties.
 */
void
salut_svc_olpc_activity_properties_emit_activity_properties_changed (gpointer instance,
    guint arg_room,
    GHashTable *arg_properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES));
  g_signal_emit (instance,
      olpc_activity_properties_signals[SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged],
      0,
      arg_room,
      arg_properties);
}

static inline void
salut_svc_olpc_activity_properties_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.laptop.Telepathy.ActivityProperties");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_OLPC_ACTIVITY_PROPERTIES, &interface);

  olpc_activity_properties_signals[SIGNAL_OLPC_ACTIVITY_PROPERTIES_ActivityPropertiesChanged] =
  g_signal_new ("activity-properties-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  dbus_g_object_type_install_info (salut_svc_olpc_activity_properties_get_type (),
      &_salut_svc_olpc_activity_properties_object_info);
}
static void
salut_svc_olpc_activity_properties_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_olpc_activity_properties_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_olpc_activity_properties_methods[] = {
  { (GCallback) salut_svc_olpc_activity_properties_set_properties, _salut_ext_marshal_VOID__UINT_BOXED_POINTER, 0 },
  { (GCallback) salut_svc_olpc_activity_properties_get_properties, g_cclosure_marshal_VOID__UINT_POINTER, 85 },
};

static const DBusGObjectInfo _salut_svc_olpc_activity_properties_object_info = {
  0,
  _salut_svc_olpc_activity_properties_methods,
  2,
"org.laptop.Telepathy.ActivityProperties\0SetProperties\0A\0room\0I\0u\0properties\0I\0a{sv}\0\0org.laptop.Telepathy.ActivityProperties\0GetProperties\0A\0room\0I\0u\0properties\0O\0F\0N\0a{sv}\0\0\0",
"org.laptop.Telepathy.ActivityProperties\0ActivityPropertiesChanged\0\0",
"\0\0",
};

static const DBusGObjectInfo _salut_svc_olpc_buddy_info_object_info;

struct _SalutSvcOLPCBuddyInfoClass {
    GTypeInterface parent_class;
    salut_svc_olpc_buddy_info_set_properties_impl set_properties;
    salut_svc_olpc_buddy_info_get_properties_impl get_properties;
    salut_svc_olpc_buddy_info_set_activities_impl set_activities;
    salut_svc_olpc_buddy_info_get_activities_impl get_activities;
    salut_svc_olpc_buddy_info_set_current_activity_impl set_current_activity;
    salut_svc_olpc_buddy_info_get_current_activity_impl get_current_activity;
};

enum {
    SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged,
    SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged,
    SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged,
    N_OLPC_BUDDY_INFO_SIGNALS
};
static guint olpc_buddy_info_signals[N_OLPC_BUDDY_INFO_SIGNALS] = {0};

static void salut_svc_olpc_buddy_info_base_init (gpointer klass);

GType
salut_svc_olpc_buddy_info_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (SalutSvcOLPCBuddyInfoClass),
        salut_svc_olpc_buddy_info_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "SalutSvcOLPCBuddyInfo", &info, 0);
    }

  return type;
}

/**
 * salut_svc_olpc_buddy_info_set_properties_impl:
 * @self: The object implementing this interface
 * @in_properties: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetProperties on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_properties (SalutSvcOLPCBuddyInfo *self,
    GHashTable *in_properties,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_properties_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_properties,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetProperties D-Bus method
 *
 * Register an implementation for the SetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_properties_impl impl)
{
  klass->set_properties = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_properties_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetProperties on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_properties (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_properties_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_properties);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_properties:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetProperties D-Bus method
 *
 * Register an implementation for the GetProperties method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_properties (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_properties_impl impl)
{
  klass->get_properties = impl;
}

/**
 * salut_svc_olpc_buddy_info_set_activities_impl:
 * @self: The object implementing this interface
 * @in_activities: const GPtrArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetActivities on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_activities (SalutSvcOLPCBuddyInfo *self,
    const GPtrArray *in_activities,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_activities_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_activities);

  if (impl != NULL)
    {
      (impl) (self,
        in_activities,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetActivities D-Bus method
 *
 * Register an implementation for the SetActivities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_activities_impl impl)
{
  klass->set_activities = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_activities_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetActivities on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_activities (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_activities_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_activities);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_activities:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetActivities D-Bus method
 *
 * Register an implementation for the GetActivities method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_activities (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_activities_impl impl)
{
  klass->get_activities = impl;
}

/**
 * salut_svc_olpc_buddy_info_set_current_activity_impl:
 * @self: The object implementing this interface
 * @in_activity: const gchar * (FIXME, generate documentation)
 * @in_channel: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * SetCurrentActivity on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_set_current_activity (SalutSvcOLPCBuddyInfo *self,
    const gchar *in_activity,
    guint in_channel,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_set_current_activity_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->set_current_activity);

  if (impl != NULL)
    {
      (impl) (self,
        in_activity,
        in_channel,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_set_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the SetCurrentActivity D-Bus method
 *
 * Register an implementation for the SetCurrentActivity method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_set_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_set_current_activity_impl impl)
{
  klass->set_current_activity = impl;
}

/**
 * salut_svc_olpc_buddy_info_get_current_activity_impl:
 * @self: The object implementing this interface
 * @in_contact: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetCurrentActivity on interface org.laptop.Telepathy.BuddyInfo.
 */
static void
salut_svc_olpc_buddy_info_get_current_activity (SalutSvcOLPCBuddyInfo *self,
    guint in_contact,
    DBusGMethodInvocation *context)
{
  salut_svc_olpc_buddy_info_get_current_activity_impl impl = (SALUT_SVC_OLPC_BUDDY_INFO_GET_CLASS (self)->get_current_activity);

  if (impl != NULL)
    {
      (impl) (self,
        in_contact,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * salut_svc_olpc_buddy_info_implement_get_current_activity:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetCurrentActivity D-Bus method
 *
 * Register an implementation for the GetCurrentActivity method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
salut_svc_olpc_buddy_info_implement_get_current_activity (SalutSvcOLPCBuddyInfoClass *klass, salut_svc_olpc_buddy_info_get_current_activity_impl impl)
{
  klass->get_current_activity = impl;
}

/**
 * salut_svc_olpc_buddy_info_emit_properties_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_properties: GHashTable * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * PropertiesChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_properties_changed (gpointer instance,
    guint arg_contact,
    GHashTable *arg_properties)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged],
      0,
      arg_contact,
      arg_properties);
}

/**
 * salut_svc_olpc_buddy_info_emit_activities_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_activities: const GPtrArray * (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * ActivitiesChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_activities_changed (gpointer instance,
    guint arg_contact,
    const GPtrArray *arg_activities)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged],
      0,
      arg_contact,
      arg_activities);
}

/**
 * salut_svc_olpc_buddy_info_emit_current_activity_changed:
 * @instance: The object implementing this interface
 * @arg_contact: guint  (FIXME, generate documentation)
 * @arg_activity: const gchar * (FIXME, generate documentation)
 * @arg_channel: guint  (FIXME, generate documentation)
 *
 * Type-safe wrapper around g_signal_emit to emit the
 * CurrentActivityChanged signal on interface org.laptop.Telepathy.BuddyInfo.
 */
void
salut_svc_olpc_buddy_info_emit_current_activity_changed (gpointer instance,
    guint arg_contact,
    const gchar *arg_activity,
    guint arg_channel)
{
  g_assert (instance != NULL);
  g_assert (G_TYPE_CHECK_INSTANCE_TYPE (instance, SALUT_TYPE_SVC_OLPC_BUDDY_INFO));
  g_signal_emit (instance,
      olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged],
      0,
      arg_contact,
      arg_activity,
      arg_channel);
}

static inline void
salut_svc_olpc_buddy_info_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[1] = {
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  interface.dbus_interface = g_quark_from_static_string ("org.laptop.Telepathy.BuddyInfo");
  tp_svc_interface_set_dbus_properties_info (SALUT_TYPE_SVC_OLPC_BUDDY_INFO, &interface);

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_PropertiesChanged] =
  g_signal_new ("properties-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, G_TYPE_VALUE)));

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_ActivitiesChanged] =
  g_signal_new ("activities-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_BOXED,
      G_TYPE_NONE,
      2,
      G_TYPE_UINT,
      (dbus_g_type_get_collection ("GPtrArray", (dbus_g_type_get_struct ("GValueArray", G_TYPE_STRING, G_TYPE_UINT, G_TYPE_INVALID)))));

  olpc_buddy_info_signals[SIGNAL_OLPC_BUDDY_INFO_CurrentActivityChanged] =
  g_signal_new ("current-activity-changed",
      G_OBJECT_CLASS_TYPE (klass),
      G_SIGNAL_RUN_LAST|G_SIGNAL_DETAILED,
      0,
      NULL, NULL,
      _salut_ext_marshal_VOID__UINT_STRING_UINT,
      G_TYPE_NONE,
      3,
      G_TYPE_UINT,
      G_TYPE_STRING,
      G_TYPE_UINT);

  dbus_g_object_type_install_info (salut_svc_olpc_buddy_info_get_type (),
      &_salut_svc_olpc_buddy_info_object_info);
}
static void
salut_svc_olpc_buddy_info_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      salut_svc_olpc_buddy_info_base_init_once (klass);
    }
}
static const DBusGMethodInfo _salut_svc_olpc_buddy_info_methods[] = {
  { (GCallback) salut_svc_olpc_buddy_info_set_properties, _salut_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) salut_svc_olpc_buddy_info_get_properties, g_cclosure_marshal_VOID__UINT_POINTER, 67 },
  { (GCallback) salut_svc_olpc_buddy_info_set_activities, _salut_ext_marshal_VOID__BOXED_POINTER, 150 },
  { (GCallback) salut_svc_olpc_buddy_info_get_activities, g_cclosure_marshal_VOID__UINT_POINTER, 217 },
  { (GCallback) salut_svc_olpc_buddy_info_set_current_activity, _salut_ext_marshal_VOID__STRING_UINT_POINTER, 300 },
  { (GCallback) salut_svc_olpc_buddy_info_get_current_activity, g_cclosure_marshal_VOID__UINT_POINTER, 378 },
};

static const DBusGObjectInfo _salut_svc_olpc_buddy_info_object_info = {
  0,
  _salut_svc_olpc_buddy_info_methods,
  6,
"org.laptop.Telepathy.BuddyInfo\0SetProperties\0A\0properties\0I\0a{sv}\0\0org.laptop.Telepathy.BuddyInfo\0GetProperties\0A\0contact\0I\0u\0properties\0O\0F\0N\0a{sv}\0\0org.laptop.Telepathy.BuddyInfo\0SetActivities\0A\0activities\0I\0a(su)\0\0org.laptop.Telepathy.BuddyInfo\0GetActivities\0A\0contact\0I\0u\0activities\0O\0F\0N\0a(su)\0\0org.laptop.Telepathy.BuddyInfo\0SetCurrentActivity\0A\0activity\0I\0s\0channel\0I\0u\0\0org.laptop.Telepathy.BuddyInfo\0GetCurrentActivity\0A\0contact\0I\0u\0activity\0O\0F\0N\0s\0channel\0O\0F\0N\0u\0\0\0",
"org.laptop.Telepathy.BuddyInfo\0PropertiesChanged\0org.laptop.Telepathy.BuddyInfo\0ActivitiesChanged\0org.laptop.Telepathy.BuddyInfo\0CurrentActivityChanged\0\0",
"\0\0",
};


